function [region,curv1,curv2,map] = stabcont2D(varargin)
% Stability area for n-D 

% Parse input arguments
  
global PGLOBAL;
eval('PGLOBAL.FORMAT;',...
     'error(''Use PINIT to initialize the Polynomial Toolbox.'');');

n_input = nargin; expr_str = ''; n_P = 0; P_iY = [];
N_iY_1 = 0; degree = 0;pom = 0;

eval('PGLOBAL.VERBOSE;', 'painit;');
if ~n_input
    error('Not enough input arguments.')
end

degree_num = deg(varargin{1})+1;
degree_den = deg(varargin{2})+1;
    
if degree_den > degree_num
    degree = degree_den;
elseif degree_den < degree_num
    degree = degree_num;
else
    degree = degree_den;
end

if degree_num == 1
    numer = pol(varargin{1});
    denumer = varargin{2};
elseif degree_den == 1
    numer = varargin{1};
    denumer = pol(varargin{2});
else
    numer = varargin{1};
    denumer = varargin{2};
end

for ii = 0 : degree-1
    num{ii+1} = num2str(numer{ii});
    den{ii+1} = num2str(denumer{ii});
end

jj = 1;
if strcmp(class(varargin{3}),'char')
        if strcmp(varargin{3},'PI') | strcmp(varargin{3},'pi') %(varargin{3} == 'PI') | (varargin{3} == 'pi')
            a{1} = ['(' '(' num{1} ').* Y' ')'];
            while jj <= degree
                if jj == degree
                    a{jj+1} = ['(' '(' num{jj} ').*X +(' den{jj} ')' ')'];
                else
                    a{jj+1} = ['(' '(' num{jj+1} ').* Y +(' num{jj} ').*X +(' den{jj} ')' ')'];
                end
%                 a{jj+1} = ['(' '(' num{jj+1} ').* Y +(' num{jj} ').*X +(' den{jj} ')' ')'];
                jj = jj + 1;
            end
            par1 = 'K_P';  % X
            par2 = 'K_I';  % Y
            keyswitch = 0;
        end
        if strcmp(varargin{3},'PD') | strcmp(varargin{3},'pd') %(varargin{3} == 'PD') | (varargin{3} == 'pd')
            a{1} = ['(' '(' den{1} ')+(' num{1} ').*X' ')'];
            while jj < degree
%                 if jj == degree
%                     a{jj+1} = ['(' '(' num{jj} ').*Y' ')'];
%                 else
%                     a{jj+1} = ['(' '(' den{jj+1} ')+(' num{jj+1} ').*X +(' num{jj} ').*Y' ')'];
%                 end
                a{jj+1} = ['(' '(' den{jj+1} ')+(' num{jj+1} ').*X +(' num{jj} ').*Y' ')'];
                jj = jj + 1;
            end
            par1 = 'K_P';  % X
            par2 = 'K_D';  % Y
            keyswitch = 0;
        end
        if strcmp(varargin{3},'PID') | strcmp(varargin{3},'pid') %(varargin{3} == 'PID') | (varargin{3} == 'pid')
            switch inputname(4)
                case 'Kp'
                    %vytvorit polynom pro PID se zafixovanym Kp
                    Kp = varargin{4};
                    a{1} = ['(' '(' num{1} ').*X' ')'];
                    while jj <= degree
                        if jj == degree
                            a{jj+1} = ['(' '(' num{jj} ').*' num2str(Kp) '+(' num{jj-1} ').*Y +(' den{jj} ')' ')']; 
                        elseif jj == 1
                            a{jj+1} = ['(' '(' num{jj+1} ').*X +(' num{jj} ').*' num2str(Kp) '+(' den{jj} ')' ')'];
                        else
                            a{jj+1} = ['(' '(' num{jj+1} ').*X +(' num{jj} ').*' num2str(Kp) '+(' num{jj-1} ').*Y +(' den{jj} ')' ')'];
                        end
                        jj = jj + 1;
                    end
                    par1 = 'K_I';  % X
                    par2 = 'K_D';  % Y
                case 'Ki'
                    %vytvorit polynom pro PID se zafixovanym Ki
                    Ki = varargin{4};
                    a{1} = ['(' '(' num{1} ').*' num2str(Ki) ')'];
                    while jj <= degree
                        if jj == degree
                            a{jj+1} = ['(' '(' num{jj} ').*Y +(' num{jj-1} ').*X +(' den{jj} ')' ')']; 
                        elseif jj == 1
                            a{jj+1} = ['(' '(' num{jj+1} ').*' num2str(Ki) '+(' num{jj} ').*Y +(' den{jj} ')' ')'];
                        else
                            a{jj+1} = ['(' '(' num{jj+1} ').*' num2str(Ki) '+(' num{jj} ').*Y +(' num{jj-1} ').*X +(' den{jj} ')' ')'];
                        end
                        jj = jj + 1;
                    end
                    par1 = 'K_D';  % X
                    par2 = 'K_P';  % Y
                case 'Kd'
                    %vytvorit polynom pro PID se zafixovanym Kd
                    Kd = varargin{4};
                    a{1} = ['(' '(' num{1} ').*X' ')'];
                    while jj <= degree
                        if jj == degree
                            a{jj+1} = ['(' '(' num{jj} ').*Y +(' num{jj-1} ').*' num2str(Kd) '+(' den{jj} ')' ')']; 
                        elseif jj == 1
                            a{jj+1} = ['(' '(' num{jj+1} ').*X +(' num{jj} ').*Y +(' den{jj} ')' ')'];
                        else
                            a{jj+1} = ['(' '(' num{jj+1} ').*X +(' num{jj} ').*Y +(' num{jj-1} ').*' num2str(Kd) '+(' den{jj} ')' ')'];
                        end
                        jj = jj + 1;
                    end
                    par1 = 'K_I';  % X
                    par2 = 'K_P';  % Y
            end
            keyswitch = 1;
        end
else
    error('Type of controller must be class of string or is not specified.');
end

% Create grid & stability region
n_expr = jj;
degree = jj - 1;
switch keyswitch
    case 0
        switch nargin
            case 3
                int = -10:0.05:10;
                [X,Y] = meshgrid(int);
                [region,curv1,curv2,map] = hermint2D(a,degree,n_expr,par1,par2,X,Y,int);
            case 4
                int = varargin{4};
                [X,Y] = meshgrid(int);
                [region,curv1,curv2,map] = hermint2D(a,degree,n_expr,par1,par2,X,Y,int);
            case 5
                int1 = varargin{4};
                int2 = varargin{5};
                [X,Y] = meshgrid(int1,int2);
                [region,curv1,curv2,map] = hermint2D(a,degree,n_expr,par1,par2,X,Y,int1,int2);
		end
    case 1
        switch nargin
            case 4
                int = -10:0.05:10;
                [X,Y] = meshgrid(int);
                [region,curv1,curv2,map] = hermint2D(a,degree,n_expr,par1,par2,X,Y,int);
            case 5
                int = varargin{5};
                [X,Y] = meshgrid(int);
                [region,curv1,curv2,map] = hermint2D(a,degree,n_expr,par1,par2,X,Y,int);
            case 6
                int1 = varargin{5};
                int2 = varargin{6};
                [X,Y] = meshgrid(int1,int2);
                [region,curv1,curv2,map] = hermint2D(a,degree,n_expr,par1,par2,X,Y,int1,int2);
		end
end

